-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.Game.release>=9 then
lib.classes["SHAMAN"] = {}
lib.classpreload["SHAMAN"] = function()
	lib.InitPower()
	lib.InitCleave()
	--lib.AddSet("T17",{115575,115576,115577,115578,115579})
	--lib.AddSet("T18",{124293,124297,124302,124303,124308})
	--lib.AddSet("T20",{147178,147180,147175,147176,147177,147179})
	lib.AddSpell("Astral Shift",{108271},true)
	lib.AddSpell("Healing Surge",{8004})
	lib.AddSpell("Flame Shock",{188389},"target")
	lib.SetDOT("Flame Shock")
	lib.SetAuraRefresh("Flame Shock",18*0.3)
	lib.AddSpell("Lightning Bolt",{188196})
	lib.AddSpell("Chain Lightning",{188443})
	lib.AddCleaveSpell("Chain Lightning")
	lib.AddCleaveSpell("Lightning Bolt")
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Shear")
	table.insert(cfg.plistdps,"Cleanse")
	table.insert(cfg.plistdps,"Purge")
	table.insert(cfg.plistdps,"Astral Shift")
	table.insert(cfg.plistdps,"Healing Surge")
end
-- ELEMENTAL SPEC
lib.classes["SHAMAN"][1] = function() --Elem
	
	cfg.talents={
		["Exposed Elements"]=IsPlayerSpell(260694),
		["Echo of the Elements"]=IsPlayerSpell(108283),
		["Elemental Blast"]=IsPlayerSpell(117014),
		["Aftershock"]=IsPlayerSpell(273221),
		["Master of the Elements"]=IsPlayerSpell(16166),
		["Totem Mastery"]=IsPlayerSpell(210643),
		["Spirit Wolf"]=IsPlayerSpell(260878),
		["Earth Shield"]=IsPlayerSpell(974),
		["Static Charge"]=IsPlayerSpell(265046),
		["High Voltage"]=IsPlayerSpell(260890),
		["Storm Elemental"]=IsPlayerSpell(192249),
		["Liquid Magma Totem"]=IsPlayerSpell(192222),
		["Nature's Guardian"]=IsPlayerSpell(30884),
		["Ancestral Guidance"]=IsPlayerSpell(108281),
		["Wind Rush Totem"]=IsPlayerSpell(192077),
		["Earthen Rage"]=IsPlayerSpell(170374),
		["Primal Elementalist"]=IsPlayerSpell(117013),
		["Icefury"]=IsPlayerSpell(210714),
		["Unlimited Power"]=IsPlayerSpell(260895),
		["Stormkeeper"]=IsPlayerSpell(191634),
		["Ascendance"]=IsPlayerSpell(114050),
	}
	--lib.AddLegendary(335902)
	
	lib.AddSpell("Lava Burst",{51505})
	lib.AddSpell("Elemental Blast",{117014})
	lib.AddSpell("Earth Shock",{8042})
	
	lib.AddSpell("Fire Elemental",{198067,192249}) -- Fire ele, Storm ele
	lib.AddSpell("Storm Elemental",{192249})
	lib.AddSpell("Eye of the Storm",{157375})
	lib.AddSpell("Call Lightning",{157348})
	lib.AddSpell("Earth Elemental",{198103})
	lib.AddSpell("Earth Shield",{974})
	
	lib.AddSpell("Totem Mastery",{210643}) --202192 is Resonance totem for buff tracking purposes
	lib.AddSpell("Earthquake",{61882})
	lib.AddSpell("Liquid Magma Totem",{192222})
	lib.AddAuras("Totem Mastery",{202188,210651,210657,210660},"buff","player")
	lib.AddSpell("Frost Shock",{196840},"target")
	lib.AddSpell("Icefury",{210714},true)
	lib.AddSpell("Ascendance",{114050},true)
	lib.AddSpell("Stormkeeper",{205495,191634},true)
	lib.AddSpell("Primal Elementalist",{117013})
	lib.AddAura("Resonance Totem",202192,"buff","player")
	lib.AddAura("Lava Surge",77762,"buff","player")
	lib.AddAura("Exposed Elements",269808,"debuff","target")
	lib.SetTrackAura("Lava Surge")
	
	table.insert(cfg.plistdps,"Flame Shock_noFlame Shock")
	table.insert(cfg.plistdps,"Earth Shock_nocap")
	table.insert(cfg.plistdps,"Lava Burst")
	table.insert(cfg.plistdps,"Flame Shock_re")
	table.insert(cfg.plistdps,"Earth Shock_60")
	table.insert(cfg.plistdps,"Lightning Bolt")
	
	--[[table.insert(cfg.plistdps,"Totem Mastery")
	table.insert(cfg.plistdps,"Liquid Magma Totem_aoe3")
	table.insert(cfg.plistdps,"Stormkeeper_aoe3")
	table.insert(cfg.plistdps,"Storm Elemental_aoe4")
	table.insert(cfg.plistdps,"Storm Elemental_lightning_aoe")
	table.insert(cfg.plistdps,"Storm Elemental_eye_aoe")
	table.insert(cfg.plistdps,"Elemental Blast")
	table.insert(cfg.plistdps,"Lava Burst_aoe3")
	table.insert(cfg.plistdps,"Chain Lightning_aoe4")
	table.insert(cfg.plistdps,"Flame Shock_noFlame Shock")
	table.insert(cfg.plistdps,"Flame Shock_noFlame Shock_re")
	table.insert(cfg.plistdps,"Fire Elemental")
	table.insert(cfg.plistdps,"Storm Elemental")
	table.insert(cfg.plistdps,"Earth Elemental")
	table.insert(cfg.plistdps,"Ascendance")
	table.insert(cfg.plistdps,"Earth Shock_Ascendance")
	table.insert(cfg.plistdps,"Lava Burst_Ascendance")
	table.insert(cfg.plistdps,"Liquid Magma Totem")
	table.insert(cfg.plistdps,"Stormkeeper")
	table.insert(cfg.plistdps,"Earthquake_aoe3")
	table.insert(cfg.plistdps,"Earth Shock_92")
	table.insert(cfg.plistdps,"Lava Burst_buffed")
	table.insert(cfg.plistdps,"Frost Shock_Icefury")
	table.insert(cfg.plistdps,"Totem Mastery_9")
	table.insert(cfg.plistdps,"Earth Shock_60")
	table.insert(cfg.plistdps,"Icefury")
	table.insert(cfg.plistdps,"Chain Lightning_cleave")
	table.insert(cfg.plistdps,"Lightning Bolt")]]
	table.insert(cfg.plistdps,"end")

	cfg.plistaoe = nil

	cfg.plist=cfg.plistdps

	cfg.case = {
		["Earth Shock_nocap"] = function()
			--if lib.GetAura({"Exposed Elements"}) > 0 then return nil end
			if (cfg.Power.now>=90) or
				(lib.SpellCasting("Lava Burst") and cfg.Power.now>=80) or
				(lib.SpellCasting("Icefury") and cfg.Power.now>=65) or
				(lib.SpellCasting("Lightning Bolt") and cfg.Power.now>=82) or
				(lib.SpellCasting("Chain Lightning") and cfg.Power.now>=78) then
				return lib.SimpleCDCheck("Earth Shock")
			end
			return nil
		end,
		["Earth Shock_60"] = function()
			if (cfg.Power.now>=60) then
				return lib.SimpleCDCheck("Earth Shock")
			end
			return nil
		end,
		["Healing Surge"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 then
			return lib.SimpleCDCheck("Healing Surge")
		end
			return nil
		end,
		
		--[[
		["Ascendance"] = function()
			if lib.GetAura({"Flame Shock"})<lib.GetSpellCD("Ascendance")+15 then return nil end
			if cfg.talents["Totem Mastery"] and lib.GetAura({"Resonance Totem"})<lib.GetSpellCD("Ascendance")+15 then return nil end
			if lib.GetSpellCharges("Lava Burst")>1 then return nil end
			return lib.SimpleCDCheck("Ascendance",lib.GetAura({"Ascendance"}))
		end,
		["Chain Lightning_aoe4"] = function()
			if cfg.Cleave.num>=4 and cfg.Power.now<((cfg.Power.max-(cfg.Cleave.num*4))-10) then
				return lib.SimpleCDCheck("Chain Lightning")
			end
			return nil
		end,
		["Chain Lightning_cleave"] = function()
			if cfg.Cleave.num>=2 and cfg.Power.now<((cfg.Power.max-(cfg.Cleave.num*4))-5) then
				return lib.SimpleCDCheck("Chain Lightning")
			end
			return nil
		end,
		["Earth Elemental"] = function()
			if cfg.talents["Primal Elementalist"] and UnitName("pet") == "Primal Fire Elemental" then return nil end
			if not cfg.talents["Primal Elementalist"] and UnitName("pet") == "Fire Elemental" then return nil end
			return lib.SimpleCDCheck("Earth Elemental")
		end,
		["Earthquake_aoe3"] = function()
			if cfg.Cleave.num>=3 and cfg.Power.now>=60 then
				return lib.SimpleCDCheck("Earthquake")
			end
			return nil
		end,
		["Earth Shock_Ascendance"] = function()
			if lib.GetAura({"Ascendance"}) > 0 and (cfg.Power.now>=92) then
				return lib.GetSpellCD("Earth Shock")
			end
			return nil
		end,
		["Earth Shock_92"] = function()
			if lib.GetAura({"Exposed Elements"}) > 0 then return nil end
			if (cfg.Power.now>=92) or
				(lib.SpellCasting("Lava Burst") and cfg.Power.now>=78) or
				(lib.SpellCasting("Icefury") and cfg.Power.now>=66) or
				(lib.SpellCasting("Lightning Bolt") and cfg.Power.now>=82) or
				(lib.SpellCasting("Chain Lightning") and cfg.Power.now>=78) then
				return lib.SimpleCDCheck("Earth Shock")
			end
			return nil
		end,
		["Earth Shock_60"] = function()
			if (cfg.Power.now>=60) and lib.GetAura({"Lava Surge"}) == 0 then
				return lib.SimpleCDCheck("Earth Shock")
			end
			return nil
		end,
		["Fire Elemental"] = function()
			if cfg.talents["Primal Elementalist"] and UnitName("pet") == "Primal Earth Elemental" then return nil end
			if not cfg.talents["Primal Elementalist"] and UnitName("pet") == "Earth Elemental" then return nil end
				return lib.SimpleCDCheck("Fire Elemental")
		end,
		["Flame Shock_noFlame Shock"] = function()
			return lib.SimpleCDCheck("Flame Shock",(lib.GetAura({"Flame Shock"})))
		end,
		["Flame Shock_noFlame Shock_re"] = function()
			return lib.SimpleCDCheck("Flame Shock",(lib.GetAura({"Flame Shock"})-5.4))
		end,
		["Frost Shock_Icefury"] = function()
			if (cfg.noaoe or cfg.Cleave.num<4) and (lib.SpellCasting("Icefury") or lib.GetAura({"Icefury"})>lib.GetSpellCD("Frost Shock")) then
				return lib.SimpleCDCheck("Frost Shock")
			end
			return nil
		end,
		["Lava Burst_Ascendance"] = function()
			if lib.GetAura({"Ascendance"}) > 0 then
				return lib.GetSpellCD("Lava Burst")
			end
			return nil
		end,
		["Lava Burst_aoe3"] = function()
			if cfg.Power.now>=cfg.Power.max-10 then return nil end
			if cfg.Cleave.num>=3 and lib.GetAura({"Lava Surge"}) > 0 then
				return lib.SimpleCDCheck("Lava Burst")
			end
			return nil
		end,
		["Lava Burst_buffed"] = function()
			if cfg.Power.now>=cfg.Power.max-10 then return nil end
			if lib.GetSpellCharges("Lava Burst")>1 or
			lib.GetAura({"Ascendance"})>lib.GetSpellCD("Lava Burst")+lib.GetSpellCT("Lava Burst") or --if you can cast lava burst before ascendance ends
			lib.GetAura({"Lava Surge"})>lib.GetSpellCD("Lava Burst") then --lava surge is free and instant
				if lib.GetAura({"Flame Shock"})>lib.GetSpellCD("Lava Burst")+lib.GetSpellCT("Lava Burst") then --can cast lava burst before flame shock falls off
					return lib.SimpleCDCheck("Lava Burst")
				end
			else
				if lib.SpellCasting("Lava Burst") then
					if lib.GetAura({"Flame Shock"})>lib.GetSpellCD("Lava Burst")+lib.GetSpellCT("Lava Burst")+8 then
						return lib.SimpleCDCheck("Lava Burst",lib.GetSpellCD("Lava Burst")+8)
					end
				else
					if lib.GetAura({"Flame Shock"})>lib.GetSpellCD("Lava Burst")+lib.GetSpellCT("Lava Burst") then
						return lib.SimpleCDCheck("Lava Burst")
					end
				end
			end
			return nil
		end,
		["Storm Elemental_aoe4"] = function()
			if cfg.Cleave.num>=4 and cfg.talents["Primal Elementalist"] then
				return lib.SimpleCDCheck("Storm Elemental")
			end
			return nil
		end,
		["Storm Elemental_eye_aoe"] = function()
			if cfg.Cleave.num < 4 then return nil end
			return lib.SimpleCDCheck("Eye of the Storm")
		end,
		["Storm Elemental_lightning_aoe"] = function()
			if cfg.Cleave.num<4 then return nil end
			return lib.SimpleCDCheck("Call Lightning")
		end,
		["Stormkeeper_aoe3"] = function()
			if cfg.Cleave.num<3 then return nil end
			return lib.SimpleCDCheck("Stormkeeper")
		end,
		["Totem Mastery"] = function()
			if lib.GetAura({"Resonance Totem"}) > 0 then return nil end
			return lib.SimpleCDCheck("Totem Mastery")
		end,
		["Totem Mastery_9"] = function()
			return lib.SimpleCDCheck("Totem Mastery", lib.FindTotem("Totem Mastery")-9)
		end,]]
	}

	lib.AddRangeCheck({
		{"Lightning Bolt",nil},
	})

	return true
end
-- ENHANCEMENT SPEC
lib.classes["SHAMAN"][2] = function() --Enh
	cfg.talents={
		["Lashing Flames"]=IsPlayerSpell(334046),
		["Elemental Blast"]=IsPlayerSpell(117014),
		["Hot Hand"]=IsPlayerSpell(201900),
		["Ice Strike"]=IsPlayerSpell(342240),
		["Hailstorm"]=IsPlayerSpell(334195),
		["Fire Nova"]=IsPlayerSpell(333974),
		["Crashing Storm"]=IsPlayerSpell(192246),
		["Stormkeeper"]=IsPlayerSpell(320137),
		["Sundering"]=IsPlayerSpell(197214),
		["Earthen Spike"]=IsPlayerSpell(188089),
		["Ascendance"]=IsPlayerSpell(114051),
	}
	lib.AddLegendarySpell("Doom Winds",335902)
	
	lib.AddSpell("Windstrike",{115356})
	lib.AddSpell("Lava Lash",{60103})
	lib.AddSpell("Stormstrike",{17364})
	lib.AddAura("Hot Hand",215785,"buff","player")
	lib.AddSpell("Lightning Shield",{192106},true)
	lib.AddAura("Stormbringer",201846,"buff","player")
	lib.AddSpell("Ascendance",{114051},true) -- Ascendance
	lib.SetAuraFunction("Ascendance","OnApply",function()
		cfg.spells["Stormstrike"].realid=115356
		lib.SetSpellIcon("Stormstrike")
	end)
	lib.SetAuraFunction("Ascendance","OnFade",function()
		cfg.spells["Stormstrike"].realid=17364
		lib.SetSpellIcon("Stormstrike")
	end)
--	lib.AddSpell("Lightning Bolt",{188196})
--	lib.AddSpell("Chain Lightning",{188443})
	lib.AddSpell("Feral Spirit",{51533})
	lib.AddSpell("Feral Lunge",{196884})
	lib.AddSpell("Sundering",{197214})
	lib.AddSpell("Earthen Spike",{188089})
	lib.AddSpell("Crash Lightning",{187874}) --,true
	lib.AddAura("Crash Lightning",187878,"buff","player")
	lib.AddAura("Maelstrom Weapon",344179,"buff","player")
	lib.AddAura("Hailstorm",334196,"buff","player")
	
	lib.AddCleaveSpell("Crash Lightning",nil,{210801})
	
	
	lib.AddSpell("Frost Shock",{196840},"target")
	lib.AddSpell("Chain Harvest",{320674})
	lib.AddSpell("Windfury Totem",{8512})
	lib.AddSpell("Elemental Blast",{117014})
	lib.AddSpell("Ice Strike",{342240})
	lib.AddSpell("Fire Nova",{333974})
	lib.AddSpell("Stormkeeper",{320137},true)
	lib.AddAura("Windfury Totem",327942,"buff","player","any")
	lib.AddAura("Lashing Flames",334168,"debuff","target")

	if lib.GetLegendary("Doom Winds") then
		lib.AddAura("Doom Winds_debuff",335904,"debuff","player")
		lib.AddAura("Doom Winds",335903,"buff")
		lib.AddTracking("Doom Winds",{255,0,0})
	end
	if cfg.talents["Ascendance"] then
		lib.AddTracking("Ascendance",{255,0,255})
	end
	
	lib.SetTrackAura({"Stormbringer","Hot Hand","Crash Lightning","Maelstrom Weapon"})
	
	table.insert(cfg.plistdps,"Lightning Shield")
	table.insert(cfg.plistdps,"Feral Lunge_range")
	table.insert(cfg.plistdps,"Windfury Totem_buff")
	if lib.GetLegendary("Doom Winds") then
		table.insert(cfg.plistdps,"Windfury Totem_Doom Winds")
	end
	table.insert(cfg.plistdps,"Feral Spirit")
	if cfg.talents["Hailstorm"] then
		table.insert(cfg.plistdps,"Frost Shock_Hailstorm_aoe")
	end
	if cfg.talents["Ascendance"] then
		table.insert(cfg.plistdps,"Ascendance")
	end
	if lib.GetLegendary("Doom Winds") then
		table.insert(cfg.plistdps,"Stormstrike_Doom Winds")
	end
	if cfg.talents["Sundering"] then
		table.insert(cfg.plistdps,"Sundering_aoe")
	end
	table.insert(cfg.plistdps,"Chain Harvest_aoe")
	table.insert(cfg.plistdps,"Chain Lightning_aoe")
	table.insert(cfg.plistdps,"Crash Lightning_aoe")
	if cfg.talents["Ascendance"] then
		table.insert(cfg.plistdps,"Stormstrike_Ascendance")
	end
	table.insert(cfg.plistdps,"Flame Shock_noFlame Shock")
	if cfg.talents["Lashing Flames"] then
		table.insert(cfg.plistdps,"Lava Lash_Lashing Flames")
	end
	if cfg.talents["Hailstorm"] then
		table.insert(cfg.plistdps,"Frost Shock_Hailstorm")
	end
	if cfg.talents["Earthen Spike"] then
		table.insert(cfg.plistdps,"Earthen Spike")
	end
	if cfg.talents["Stormkeeper"] then
		table.insert(cfg.plistdps,"Lightning Bolt_Stormkeeper")
	end
	if cfg.talents["Elemental Blast"] then
		table.insert(cfg.plistdps,"Elemental Blast")
	end
	table.insert(cfg.plistdps,"Chain Harvest")
	if cfg.talents["Stormkeeper"] then
		table.insert(cfg.plistdps,"Stormkeeper")
	end
	table.insert(cfg.plistdps,"Lightning Bolt_mw8")
	if cfg.talents["Hot Hand"] then
		table.insert(cfg.plistdps,"Lava Lash_Hot Hand")
	end
	
	table.insert(cfg.plistdps,"Stormstrike")
	if cfg.talents["Crashing Storm"] then
		table.insert(cfg.plistdps,"Crash Lightning")
	end
	table.insert(cfg.plistdps,"Lava Lash")
	table.insert(cfg.plistdps,"Crash Lightning")
	table.insert(cfg.plistdps,"Flame Shock_re")
	table.insert(cfg.plistdps,"Frost Shock")
	if cfg.talents["Ice Strike"] then
		table.insert(cfg.plistdps,"Ice Strike")
	end
	if cfg.talents["Sundering"] then
		table.insert(cfg.plistdps,"Sundering")
	end
	if cfg.talents["Fire Nova"] then
		table.insert(cfg.plistdps,"Fire Nova")
	end
	table.insert(cfg.plistdps,"Lightning Bolt_mw5")
	table.insert(cfg.plistdps,"end")

	cfg.plistaoe = nil

	cfg.plist=cfg.plistdps

	cfg.case = {
		["Windfury Totem_buff"] = function()
			return lib.SimpleCDCheck("Windfury Totem",lib.GetAura({"Windfury Totem"}))
		end,
		["Windfury Totem_Doom Winds"] = function()
			return lib.SimpleCDCheck("Windfury Totem",lib.GetAura({"Doom Winds_debuff"}))
		end,
		["Stormstrike_Doom Winds_aoe"] = function()
			if cfg.Cleave.num>1
			and lib.GetAura({"Doom Winds"})>lib.GetSpellCD("Stormstrike")
			and lib.GetAura({"Crash Lightning"})>lib.GetSpellCD("Stormstrike") then
				return lib.SimpleCDCheck("Stormstrike")
			end
			return nil
		end,
		["Stormstrike_Doom Winds"] = function()
			if lib.GetAura({"Doom Winds"})>lib.GetSpellCD("Stormstrike") then
				return lib.SimpleCDCheck("Stormstrike")
			end
			return nil
		end,
		["Chain Lightning_aoe"] = function()
			if cfg.Cleave.num>1 and lib.GetAuraStacks("Maelstrom Weapon")>=5 then
				return lib.SimpleCDCheck("Chain Lightning")
			end
			return nil
		end,
		["Lightning Bolt_mw5"] = function()
			if lib.GetAuraStacks("Maelstrom Weapon")>=5 then
				return lib.SimpleCDCheck("Lightning Bolt")
			end
			return nil
		end,
		["Chain Harvest"] = function()
			if lib.GetAuraStacks("Maelstrom Weapon")>=5 then
				return lib.SimpleCDCheck("Chain Harvest")
			end
			return nil
		end,
		["Chain Harvest_aoe"] = function()
			if cfg.Cleave.num>1 and lib.GetAuraStacks("Maelstrom Weapon")>=5 then
				return lib.SimpleCDCheck("Chain Harvest")
			end
			return nil
		end,
		["Crash Lightning_aoe"] = function()
			if cfg.Cleave.num>1 then
				return lib.SimpleCDCheck("Crash Lightning")
			end
			return nil
		end,
		["Stormkeeper"] = function()
			if lib.GetAuraStacks("Maelstrom Weapon")>=5 then
				return lib.SimpleCDCheck("Stormkeeper")
			end
			return nil
		end,
		["Healing Surge"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 and lib.GetAuraStacks("Maelstrom Weapon")>=5 then
			return lib.SimpleCDCheck("Healing Surge")
		end
			return nil
		end,
		["Elemental Blast"] = function()
			if lib.GetAuraStacks("Maelstrom Weapon")>=5 then
				return lib.SimpleCDCheck("Elemental Blast")
			end
			return nil
		end,
		["Lightning Bolt_mw8"] = function()
			if lib.GetAuraStacks("Maelstrom Weapon")>=8 then
				return lib.SimpleCDCheck("Lightning Bolt")
			end
			return nil
		end,
		
		["Lava Lash_Lashing Flames"] = function()
			return lib.SimpleCDCheck("Lava Lash",lib.GetAura({"Lashing Flames"}))
		end,
		["Lava Lash_Hot Hand"] = function()
			if lib.GetAura({"Hot Hand"})>lib.GetSpellCD("Lava Lash") then
				return lib.SimpleCDCheck("Lava Lash")
			end
			return nil
		end,
		["Lightning Bolt_Stormkeeper"] = function()
			if lib.GetAura({"Stormkeeper"})>lib.GetSpellCD("Lightning Bolt") then
				return lib.SimpleCDCheck("Lightning Bolt")
			end
			return nil
		end,
		["Stormstrike_Ascendance"] = function()
			if lib.GetAura({"Ascendance"})>lib.GetSpellCD("Stormstrike") then
				return lib.SimpleCDCheck("Stormstrike")
			end
			return nil
		end,
		
		["Feral Lunge_range"] = function()
			if lib.inrange("Feral Lunge") then
				return lib.SimpleCDCheck("Feral Lunge")
			end
			return nil
		end,
		["Lightning Shield"] = function()
			return lib.SimpleCDCheck("Lightning Shield",lib.GetAura({"Lightning Shield"}))
		end,
		["Ascendance"] = function()
			return lib.SimpleCDCheck("Ascendance",lib.GetAura({"Ascendance"}))
		end,
		["Frost Shock_Hailstorm"] = function()
			if lib.GetAura({"Hailstorm"})>lib.GetSpellCD("Frost Shock") then
				return lib.SimpleCDCheck("Frost Shock")
			end
			return nil
		end,
		["Frost Shock_Hailstorm_aoe"] = function()
			if cfg.Cleave.num<2 then return nil end
			if lib.GetAura({"Hailstorm"})>lib.GetSpellCD("Frost Shock") then
				return lib.SimpleCDCheck("Frost Shock")
			end
			return nil
		end,
		["Sundering_aoe"] = function()
			if cfg.Cleave.num<2 then return nil end
			return lib.SimpleCDCheck("Sundering")
		end
	}

	lib.AddRangeCheck({
	{"Lava Lash",nil},
	{"Feral Lunge",{1,1,0,1}},
	{"Lightning Bolt",{0,0,1,1}},
	})

	return true
end

lib.classpostload["SHAMAN"] = function()
	lib.AddDispellPlayer("Cleanse",{51886},{"Curse"}) -- Cleanse Spirit
	lib.AddDispellTarget("Purge",{370},{"Magic"})
	lib.SetInterrupt("Shear",{57994})

	cfg.case["Astral Shift"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 then
			return lib.SimpleCDCheck("Astral Shift")
		end
		return nil
	end

	cfg.case["Flame Shock_noFlame Shock"] = function()
			return lib.SimpleCDCheck("Flame Shock",lib.GetAura({"Flame Shock"}))
	end
	cfg.case["Flame Shock_re"] = function()
		return lib.SimpleCDCheck("Flame Shock",lib.GetAura({"Flame Shock"})-lib.GetAuraRefresh("Flame Shock"))
	end
--[[	cfg.case["Healing Surge"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 and cfg.Power.now>=20 then
			return lib.SimpleCDCheck("Healing Surge")
		end
		return nil
	end]]

	--lib.UpdateTotem(1)

	--[[function Heddclassevents.PLAYER_ENTERING_WORLD()
		lib.UpdateTotem(1)
	end]]

	--[[function Heddclassevents.PLAYER_TOTEM_UPDATE(...)
		lib.UpdateTotem(1)
	end]]

	--[[lib.myonupdate = function()
		lib.GroundUpdate()
	end]]

	lib.CD = function()
		lib.CDadd("Shear")
		lib.CDadd("Purge")
		lib.CDadd("Cleanse")
		lib.CDadd("Astral Shift")
		lib.CDadd("Healing Surge")
		lib.CDadd("Lightning Shield")
		lib.CDadd("Feral Lunge")
		lib.CDadd("Stormkeeper")
		--[[lib.CDadd("Earth Elemental")
		if cfg.talents["Storm Elemental"] then
			lib.CDadd("Storm Elemental")
		else
			lib.CDadd("Fire Elemental")
		end]]
		--lib.CDadd("Liquid Magma Totem")
		
		--lib.CDadd("Sundering")
		--lib.CDadd("Totem Mastery")
		lib.CDadd("Feral Spirit")
		lib.CDaddTimers("Feral Spirit","Feral Spirit",function(self, event, unitID, castid, SpellID)
			if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and SpellID==lib.GetSpellID("Feral Spirit") then
				CooldownFrame_SetTimer(self.cooldown,GetTime(),15,1)
			end
		end
		,{"UNIT_SPELLCAST_SUCCEEDED"})

		lib.CDadd("Ascendance")
		lib.CDadd("Chain Harvest")
		lib.CDadd("Windfury Totem")
		--lib.CDadd("Heroism")
		--lib.CDaddTimers("Heroism","Exhaustion","auras",nil,true,{0, 1, 0})
		--lib.CDturnoff("Heroism")
		--lib.CDadd("Crash Lightning")
	end
end
end
